<%
const properties = { // What should be displayed where on the item view page?
    "general":[
      "type",
      "weight",
      "delay",
      "refine",
      "dropAnnounce",
      "stack",
      "floorLifeTime"
    ],
    "specific":[
      "atk",
      "def",
      "matk",
      "range",
      "minRange",
      "weaponLv",
      "equipLv"
    ],
    "expert":[
      "aegisName",
      "subtype",
      "viewSprite",
      "dyeString",
      "slots",
      "job",
      "upper",
      "gender",
      "disableOptions",
      "bindOnEquip",
      "forceSerial",
      "keepAfterUse",
      "buyingStore",
      "allowPickup",
    ]
  }
  const scripting_params = [{ 
        property: "script",
        summary: "Script",
        description: "Script to execute when the item is used/equipped."
    }, {
        property: "onEquipScript",
        summary: "OnEquipScript", 
        description: "Script to execute when the item is equipped. Warning, not all item bonuses will work here as expected."
    }, { 
        property: "onUnequipScript",
        summary: "OnUnequipScript",
        description: "Script to execute when the item is unequipped. Warning, not all item bonuses will work here as expected."
    }];
    
    const restrictions_params = [{
        property: "trade",
        summary: "This Item has Trade restrictions"
    }, {
        property: "nouse",
        summary: "This Item has Use restrictions"
    }];
%>


<div class="card">
    <div class="container">
        <div class="row" style="flex-wrap: nowrap;">
            <div class="column column-grow">
                <h1>
                    <%= item.name %> |
                    <%= item.id %>
                </h1>
                <blockquote>
                    <p>
                        <em>
                            <%= item.description %>
                        </em>
                    </p>
                </blockquote>
                <% if (null != item.effect) { %>
                <h5>
                    <b>
                        <%= item.effect %>
                    </b>
                </h5>
                <% } %>
            </div>
            <div class="column no-padding">
                <div class="icon-container">
                    <img src="<%= ( item.image ?  `${api_path}${item.id}.png` : 'error.png' ) %>" width="100%"></img>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="column column-grow">
                <table style="width: 100%;">
                    <tbody>
                        <tr>
                            <td><b>ID</b></td>
                            <td><%= item.id %></td>
                        </tr>
                        <% for(prop of properties.general) { %>
                           <%- include("old_partials/property_row.ejs") %>
                        <% } %>
                    </tbody>
                </table>
            </div>
            <div class="column column-grow">
                <table>
                    <tbody>
                        <% for(prop of properties.specific) { %>
                            <%- include("old_partials/property_row.ejs") %>
                        <% } %>
                    </tbody>
                </table>
            </div>
        </div>
        <div class="">
            <h4>Mobs that drop this item:</h4>
            <% if(mobs_that_drop_it.length >= 1) { %>
            <div class="column column-grow">
                <table>
                    <thead>
                        <tr>
                            <th style="text-align: left">
                                Monster
                            </th>
                            <th style="text-align: left">
                                Drop Chances
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        <% for(drop of mobs_that_drop_it) { %>
                            <tr>
                                <td style="vertical-align: top">
                                  <b><%= drop.mobName %></b>
                                </td>
                                <td style="text-align: right">
                                  <%- drop.chances.join('<br />') %>
                                </td>
                              </tr>
                        <% } %>
                    </tbody>
                </table>
            </div>
            <% } else { %>
            <p>No Monsters drop this item.</p>
            <% } %>
        </div>
        <div class="row">
                <% restrictions_params.forEach((info) => { %>
                <% if(item[info.property]) { %>
                <p>
                    <details>
                        <summary><%= info.summary %></summary>
                        <textarea class="trade_restrict_list" readonly rows="6"><%= JSON.stringify(item[info.property], null, 3) %></textarea>
                    </details>
                </p>
                <% } %>
                <% }) %>
        </div>
        
                <div class="row">
                    <div class="column column-grow">
                        <a class="button" href="<%= wiki_path + '#'+ item.id %>">To Wiki Page</a>
                    </div>
                    <div class="column">
                        ID for use in Discord:
                        <input type="text" value="[<%= item.name %> | https://i.tmw2.org/<%= item.id %>]" readonly>
                    </div>
                </div>
                <div>
                <details>
                    <summary>Expert View</summary>
                    <div class="expert">
                        <p>You'd like to see behind the curtain? Then you are here at the right place - lots of data
                            only
                            contributors
                            would normally see.</p>
                        <a target="_blank" class="button" href="<%= api_path %><%= item.id %>.json">Open raw JSON</a>
                        <table>
                            <tbody>
                                <tr>
                                    <td><b>ID</b></td>
                                    <td>
                                        <%= item.id %>
                                    </td>
                                </tr>
                                <% for(prop of properties.expert) { %>
                                    <%- include("old_partials/property_row.ejs") %>
                                <% } %>
                            </tbody>
                        </table>
                        <% scripting_params.forEach((info) => { if (info.property in item) { %>
                        <details>
                            <summary><%= info.summary %></summary>
                            <div class="expert">
                                <p><%= info.description %></p>
                                <pre class="small-inline-script-card"><code><%= item[info.property].replace(/\t\t/g,'').trim() %></code></pre>
                            </div>
                        </details>
                        <% }})%>
                    </div>
                </details>   
                </div>        
        </div>
    </div>
</div>